var stationNames;
var stationURLs;
var currentStation;

function loadMain()
{	
	loadStationList();
	loadCurrentStation();
	dockStateChange(); // force refresh everytime Sidebar.exe relaunches

	System.Gadget.onDock = dockStateChange;
	System.Gadget.onUndock = dockStateChange;
    
	System.Gadget.settingsUI = "Settings.html";
    System.Gadget.onSettingsClosed = settingsClosed;
}

function loadCurrentStation()
{
	var tempName = System.Gadget.Settings.read("stationName");
	var currentURL = "";
	
	if (tempName != "")
	{
		currentURL = getURLByStationName(tempName);
	}
	
	if (currentURL == "") // assign a default station if no preference set
	{
		currentStation = stationNames[0];
		currentURL = stationURLs[0];
	}
	else
	{
		currentStation = tempName;
	}
	
	setMediaPlayer(currentURL);
}

function getURLByStationName(stationName)
{
	for (i=0;i<stationNames.length;i++)
	{
		if (stationNames[i] == stationName)
			return stationURLs[i];
	}
	return "";
}

function setMediaPlayer(stationURL)
{
	mediaPlayer.url = stationURL;
	updateNowPlaying();
}

function initStationList()
{
	stationNames = new Array();
	stationURLs = new Array();

	stationNames[0] = ".777 Easy Classical Channel";
	stationURLs[0]  = "http://www.luckysevenradio.com/wm/classical_hi.asx";
	
	stationNames[1] = "Bach-Radio.com";
    stationURLs[1]  = "http://www.1.fm/TuneIn/WM/energyBaroque128k/Listen.aspx";
	
	stationNames[2] = "Beethoven.com";
	stationURLs[2]  = "http://repc-1.adinjector.net/amtmsvc/gateway.asp?stationid=29&adformat=2";
	
	stationNames[3] = "Infinite Classical";
	stationURLs[3]  = "http://infiniteclassical.com/c1.asx";

	stationNames[4] = "Minesota Public Radio";
	stationURLs[4]  = "http://minnesota.publicradio.org/tools/play/streams/classical.asx";

	stationNames[5] = "MSN Classical Essentials";
	stationURLs[5]  = "http://radio.msn.com/asx/generate.aspx?type=genre&id=10002382";

	stationNames[6] = "radioioCLASSICAL";
	stationURLs[6]  = "http://www.searchplay.com/radioioClassical/A2hi.asx";

	stationNames[7] = "WCPE - North Carolina";
	stationURLs[7]  = "http://play.rbn.com/play.asx?url=wcpe/wcpeint/wmdemand/preroll.asf&proto=mms?url=wcpe/wcpeint/wmlive/wcpewin.asf?mswmext=.asx";

	stationNames[8] = "WGUC - Cincinnati's Classical";
	stationURLs[8]  = "http://www.wguc.org/listen/WGUCLive.asx";

	stationNames[9] = "WIAA - Interlochen";
	stationURLs[9]  = "http://www.publicbroadcasting.net/wiaa/ppr/wiaa.asx";
	
	updateStationSetting();
}

function updateStationSetting()
{
	var stationCount = stationNames.length;
	System.Gadget.Settings.write("stationCount", stationCount);

	for (i=0;i<stationCount;i++)
	{
		System.Gadget.Settings.writeString("station"+i.toString(), stationNames[i]);
		System.Gadget.Settings.writeString("url"+i.toString(),     stationURLs[i]);
	}
}

function loadStationList()
{
	stationNames = new Array();
	stationURLs = new Array();
	var stationCount = 0;
	
	stationCount = System.Gadget.Settings.read("stationCount");

	if (stationCount > 0)
	{
		for (i=0;i<stationCount;i++)
		{
			stationNames[i] = System.Gadget.Settings.readString("station"+i.toString());
			stationURLs[i]  = System.Gadget.Settings.readString("url"+i.toString());
		}
	}
	else
	{
		initStationList();
	}
}

function dockStateChange()
{
	if(!System.Gadget.docked) 
    { // undocked
        with(document.body.style)
			width=205,
			height=155;
		with(bkgImage.style)
			width=205,
			height=155;
		bkgImage.src = "url(images/bkg.png)";
		with(playbackStatus.style)
			left=88,
			top=74,
			width=120;
		with(nowPlaying.style)
			left=70,
			top=109,
			width=136;
		with(playbackControls.style)
			left=152,
			top=63;
		controlImageMouse(false);
    } 
    else
    { // docked
        with(document.body.style)
			width=135,
			height=63;
		with(bkgImage.style)
			width=135,
			height=63;
			bkgImage.src = "images/bkg_docked.png";
		with(playbackStatus.style)
			left=18,
			top=12,
			width=80;
		with(nowPlaying.style)
			left=18,
			top=36,
			width=100;
		with(playbackControls.style)
			left=100,
			top=8;
		controlImageMouse(false);
    }
}

function settingsClosed() 
{
	//loadCurrentStation();
	//controlImageMouse(false);
	loadMain();
}

function controlImageClick()
{		
	if (controlImage.src.indexOf("stop") > 0)
	{
		mediaPlayer.controls.stop();
	}
	else
	{
		mediaPlayer.controls.play();
	}
}

function controlImageMouse(isMouseOn)
{
	var isDocked = System.Gadget.docked;
	if (controlImage.src.indexOf("stop") > 0)
	{
		controlImage.src = "images/stop" + (isMouseOn?"_hover":"") + (isDocked?"_sm.png":".png");
	}
	else
	{
		controlImage.src = "images/play" + (isMouseOn?"_hover":"") + (isDocked?"_sm.png":".png");
	}
}

function updateNowPlaying()
{
	var nowPlayingText = "<MARQUEE WIDTH='100' SCROLLDELAY='80' SCROLLAMOUNT='2'><div id='nowPlayingText'><font color='white'><b>" + currentStation + " --- " + mediaPlayer.url + "</b></font></div></MARQUEE>";
	nowPlaying.innerHTML = nowPlayingText;
}

function playStateChange(newstate)
{
	
	switch (newstate){ 
	case 1: // Stopped
		playbackStatus.innerHTML = "Stopped";
		controlImage.src = controlImage.src.replace(/stop/, "play");
		break;

	case 2: // Paused
		playbackStatus.innerHTML = "Paused";
		controlImage.src = controlImage.src.replace(/stop/, "play");
		break;
	
	case 3: // Playing
		playbackStatus.innerHTML = "Playing";
		controlImage.src = controlImage.src.replace(/play/, "stop");
		break;

	case 6: // Buffering
		playbackStatus.innerHTML = "Buffering";
		break;

	case 7: // Waiting
		playbackStatus.innerHTML = "Waiting";
		break;

	case 8: // Media Ended
		playbackStatus.innerHTML = "Media Ended";
		controlImage.src = controlImage.src.replace(/stop/, "play");
		break;

	case 9: // Transitioning
		playbackStatus.innerHTML = "Connecting";
		break;

	case 10: // Ready
		playbackStatus.innerHTML = "Ready";
		controlImage.src = controlImage.src.replace(/stop/, "play");
		break;
	}
}